import curses
import serial, time

# open the device
ser = serial.Serial('COM3', 9600)  # open serial port
print("Opened serial device", ser.name)

# enter the full-screen text display
stdscr = curses.initscr()

# disable the usual line buffering
curses.cbreak()

try:
    kp=40
    while True:
        # this will wait for a key to be pressed
        key = stdscr.getkey()
        stdscr.addstr(0, 0, "User typed key %s" % key)
        stdscr.refresh()

        if key == 'a':
            stdscr.addstr(1, 0, "left    ")
            ser.write(b'$0,1,0,0,0,0,0,0,0,0#')     # write a string to the robot
            
        elif key == 'd':
            stdscr.addstr(1, 0, "right   ")
            ser.write(b'$4,0,0,0,0,0,0,0,0,0#')
            
        elif key == 'w':
            stdscr.addstr(1, 0, "forward ")
            ser.write(b'$1,0,0,0,0,0,0,0,0,0#')
        elif key == 's':
            stdscr.addstr(1, 0, "stop    ")
            ser.write(b'$0,0,0,0,0,0,0,0,0,0#')
        elif key == 'x':
            stdscr.addstr(1, 0, "reverse ")
            ser.write(b'$2,0,0,0,0,0,0,0,0,0#')
        elif key == '.':
            kp = kp+1
            stdscr.addstr(1, 1, "kp = " + str(kp))
            ser.write(b'$0,0,0,0,1,1,AP%5.2f,AD0.60,VP5.20,VI0.25#'%(kp))
        elif key == ',':
            kp = kp-1
            stdscr.addstr(1, 1, "kp = " + str(kp))
            ser.write(b'$0,0,0,0,1,1,AP%5.2f,AD0.60,VP5.20,VI0.25#'%(kp))
        elif key == 'r':
            stdscr.addstr(1, 0, "reset ")
            ser.write(b'$R,0,0,0,0,0,0,0,0,0#')
        elif key == 'q':
            stdscr.addstr(1, 0, "quitting ")
            break
        
except KeyboardInterrupt:
    print("User typed control-c to quit.")    

# shut down the full-screen text
curses.nocbreak()
curses.endwin()

# if the screen doesn't reset properly, use the 'reset' command at the terminal


    
